QCPPolarAxisRadial Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Signals | Protected Functions
QCPPolarAxisRadial Class Reference

The radial axis inside a radial plot. More...

Inheritance diagram for QCPPolarAxisRadial:

## Public Types
enum | AngleReference
enum | ScaleType
enum | SelectablePart
enum | LabelMode

## Public Functions
| QCPPolarAxisRadial (QCPPolarAxisAngular *parent)
bool | rangeDrag () const
bool | rangeZoom () const
double | rangeZoomFactor () const
QCPPolarAxisAngular * | angularAxis () const
ScaleType | scaleType () const
const QCPRange | range () const
bool | rangeReversed () const
double | angle () const
AngleReference | angleReference () const
QSharedPointer< QCPAxisTicker > | ticker () const
bool | ticks () const
bool | tickLabels () const
int | tickLabelPadding () const
QFont | tickLabelFont () const
QColor | tickLabelColor () const
double | tickLabelRotation () const
LabelMode | tickLabelMode () const
QString | numberFormat () const
int | numberPrecision () const
QVector< double > | tickVector () const
QVector< double > | subTickVector () const
QVector< QString > | tickVectorLabels () const
int | tickLengthIn () const
int | tickLengthOut () const
bool | subTicks () const
int | subTickLengthIn () const
int | subTickLengthOut () const
QPen | basePen () const
QPen | tickPen () const
QPen | subTickPen () const
QFont | labelFont () const
QColor | labelColor () const
QString | label () const
int | labelPadding () const
SelectableParts | selectedParts () const
SelectableParts | selectableParts () const
QFont | selectedTickLabelFont () const
QFont | selectedLabelFont () const
QColor | selectedTickLabelColor () const
QColor | selectedLabelColor () const
QPen | selectedBasePen () const
QPen | selectedTickPen () const
QPen | selectedSubTickPen () const
void | setRangeDrag (bool enabled)
void | setRangeZoom (bool enabled)
void | setRangeZoomFactor (double factor)
Q_SLOT void | setScaleType (QCPPolarAxisRadial::ScaleType type)
Q_SLOT void | setRange (const QCPRange &range)
void | setRange (double lower, double upper)
void | setRange (double position, double size, Qt::AlignmentFlag alignment)
void | setRangeLower (double lower)
void | setRangeUpper (double upper)
void | setRangeReversed (bool reversed)
void | setAngle (double degrees)
void | setAngleReference (AngleReference reference)
void | setTicker (QSharedPointer< QCPAxisTicker > ticker)
void | setTicks (bool show)
void | setTickLabels (bool show)
void | setTickLabelPadding (int padding)
void | setTickLabelFont (const QFont &font)
void | setTickLabelColor (const QColor &color)
void | setTickLabelRotation (double degrees)
void | setTickLabelMode (LabelMode mode)
void | setNumberFormat (const QString &formatCode)
void | setNumberPrecision (int precision)
void | setTickLength (int inside, int outside=0)
void | setTickLengthIn (int inside)
void | setTickLengthOut (int outside)
void | setSubTicks (bool show)
void | setSubTickLength (int inside, int outside=0)
void | setSubTickLengthIn (int inside)
void | setSubTickLengthOut (int outside)
void | setBasePen (const QPen &pen)
void | setTickPen (const QPen &pen)
void | setSubTickPen (const QPen &pen)
void | setLabelFont (const QFont &font)
void | setLabelColor (const QColor &color)
void | setLabel (const QString &str)
void | setLabelPadding (int padding)
void | setSelectedTickLabelFont (const QFont &font)
void | setSelectedLabelFont (const QFont &font)
void | setSelectedTickLabelColor (const QColor &color)
void | setSelectedLabelColor (const QColor &color)
void | setSelectedBasePen (const QPen &pen)
void | setSelectedTickPen (const QPen &pen)
void | setSelectedSubTickPen (const QPen &pen)
Q_SLOT void | setSelectableParts (const QCPPolarAxisRadial::SelectableParts &selectableParts)
Q_SLOT void | setSelectedParts (const QCPPolarAxisRadial::SelectableParts &selectedParts)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
void | moveRange (double diff)
void | scaleRange (double factor)
void | scaleRange (double factor, double center)
void | rescale (bool onlyVisiblePlottables=false)
void | pixelToCoord (QPointF pixelPos, double &angleCoord, double &radiusCoord) const
QPointF | coordToPixel (double angleCoord, double radiusCoord) const
double | coordToRadius (double coord) const
double | radiusToCoord (double radius) const
SelectablePart | getPartAt (const QPointF &pos) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Signals
void | rangeChanged (const QCPRange &newRange)
void | rangeChanged (const QCPRange &newRange, const QCPRange &oldRange)
void | scaleTypeChanged (QCPPolarAxisRadial::ScaleType scaleType)
void | selectionChanged (const QCPPolarAxisRadial::SelectableParts &parts)
void | selectableChanged (const QCPPolarAxisRadial::SelectableParts &parts)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Protected Functions
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | draw (QCPPainter *painter)
virtual QCP::Interaction | selectionCategory () const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | wheelEvent (QWheelEvent *event)
void | updateGeometry (const QPointF &center, double radius)
void | setupTickVectors ()
QPen | getBasePen () const
QPen | getTickPen () const
QPen | getSubTickPen () const
QFont | getTickLabelFont () const
QFont | getLabelFont () const
QColor | getTickLabelColor () const
QColor | getLabelColor () const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual QRect | clipRect () const
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Detailed Description

The radial axis inside a radial plot.

Warning
  In this QCustomPlot version, polar plots are a tech preview. Expect documentation and functionality to be incomplete, as well as changing public interfaces in the future.

Each axis holds an instance of QCPAxisTicker which is used to generate the tick coordinates and tick labels. You can access the currently installed ticker or set a new one (possibly one of the specialized subclasses, or your own subclass) via setTicker. For details, see the documentation of QCPAxisTicker.

## Member Enumeration Documentation

## § AngleReference

enum QCPPolarAxisRadial::AngleReference

Defines the reference of the angle at which a radial axis is tilted (setAngle).

Enumerator
arAbsolute | The axis tilt is given in absolute degrees. The zero is to the right and positive angles are measured counter-clockwise.
arAngularAxis | The axis tilt is measured in the angular coordinate system given by the parent angular axis.

## § ScaleType

enum QCPPolarAxisRadial::ScaleType

Defines the scale of an axis.

See also
  setScaleType

Enumerator
stLinear | Linear scaling.
stLogarithmic | Logarithmic scaling with correspondingly transformed axis coordinates (possibly also setTicker to a QCPAxisTickerLog instance).

## § SelectablePart

enum QCPPolarAxisRadial::SelectablePart

Defines the selectable parts of an axis.

See also
  setSelectableParts, setSelectedParts

Enumerator
spNone | None of the selectable parts.
spAxis | The axis backbone and tick marks.
spTickLabels | Tick labels (numbers) of this axis (as a whole, not individually)
spAxisLabel | The axis label.

## Constructor & Destructor Documentation

## § QCPPolarAxisRadial()

QCPPolarAxisRadial::QCPPolarAxisRadial | ( | QCPPolarAxisAngular * | parent | ) |
| explicit

Constructs an Axis instance of Type type for the axis rect parent.

Usually it isn't necessary to instantiate axes directly, because you can let QCustomPlot create them for you with QCPAxisRect::addAxis. If you want to use own QCPAxis-subclasses however, create them manually and then inject them also via QCPAxisRect::addAxis.

## Member Function Documentation

## § ticker()

QSharedPointer< QCPAxisTicker > QCPPolarAxisRadial::ticker | ( |  | ) | const
| inline

Returns a modifiable shared pointer to the currently installed axis ticker. The axis ticker is responsible for generating the tick positions and tick labels of this axis. You can access the QCPAxisTicker with this method and modify basic properties such as the approximate tick count (QCPAxisTicker::setTickCount).

You can gain more control over the axis ticks by setting a different QCPAxisTicker subclass, see the documentation there. A new axis ticker can be set with setTicker.

Since the ticker is stored in the axis as a shared pointer, multiple axes may share the same axis ticker simply by passing the same shared pointer to multiple axes.

See also
  setTicker

## § setScaleType()

void QCPPolarAxisRadial::setScaleType | ( | QCPPolarAxisRadial::ScaleType | type | ) |

Sets whether the axis uses a linear scale or a logarithmic scale.

Note that this method controls the coordinate transformation. For logarithmic scales, you will likely also want to use a logarithmic tick spacing and labeling, which can be achieved by setting the axis ticker to an instance of QCPAxisTickerLog :

customPlot->xAxis->setScaleType(QCPAxis::stLogarithmic);
customPlot->xAxis->setTicker(QSharedPointer<QCPAxisTickerLog>(new QCPAxisTickerLog));

See the documentation of QCPAxisTickerLog about the details of logarithmic axis tick creation.

setNumberPrecision

## § setRange() [1/3]

void QCPPolarAxisRadial::setRange | ( | const QCPRange & | range | ) |

Sets the range of the axis.

This slot may be connected with the rangeChanged signal of another axis so this axis is always synchronized with the other axis range, when it changes.

To invert the direction of an axis, use setRangeReversed.

## § setRange() [2/3]

void QCPPolarAxisRadial::setRange | ( | double | lower,
|  | double | upper
| ) |  |

This is an overloaded function.

Sets the lower and upper bound of the axis range.

To invert the direction of an axis, use setRangeReversed.

There is also a slot to set a range, see setRange(const QCPRange &range).

## § setRange() [3/3]

void QCPPolarAxisRadial::setRange | ( | double | position,
|  | double | size,
|  | Qt::AlignmentFlag | alignment
| ) |  |

This is an overloaded function.

Sets the range of the axis.

The position coordinate indicates together with the alignment parameter, where the new range will be positioned. size defines the size of the new axis range. alignment may be Qt::AlignLeft, Qt::AlignRight or Qt::AlignCenter. This will cause the left border, right border, or center of the range to be aligned with position. Any other values of alignment will default to Qt::AlignCenter.

## § setRangeLower()

void QCPPolarAxisRadial::setRangeLower | ( | double | lower | ) |

Sets the lower bound of the axis range. The upper bound is not changed.

See also
  setRange

## § setRangeUpper()

void QCPPolarAxisRadial::setRangeUpper | ( | double | upper | ) |

Sets the upper bound of the axis range. The lower bound is not changed.

See also
  setRange

## § setRangeReversed()

void QCPPolarAxisRadial::setRangeReversed | ( | bool | reversed | ) |

Sets whether the axis range (direction) is displayed reversed. Normally, the values on horizontal axes increase left to right, on vertical axes bottom to top. When reversed is set to true, the direction of increasing values is inverted.

Note that the range and data interface stays the same for reversed axes, e.g. the lower part of the setRange interface will still reference the mathematically smaller number than the upper part.

## § setTicker()

void QCPPolarAxisRadial::setTicker | ( | QSharedPointer< QCPAxisTicker > | ticker | ) |

The axis ticker is responsible for generating the tick positions and tick labels. See the documentation of QCPAxisTicker for details on how to work with axis tickers.

You can change the tick positioning/labeling behaviour of this axis by setting a different QCPAxisTicker subclass using this method. If you only wish to modify the currently installed axis ticker, access it via ticker.

Since the ticker is stored in the axis as a shared pointer, multiple axes may share the same axis ticker simply by passing the same shared pointer to multiple axes.

See also
  ticker

## § setTicks()

void QCPPolarAxisRadial::setTicks | ( | bool | show | ) |

Sets whether tick marks are displayed.

Note that setting show to false does not imply that tick labels are invisible, too. To achieve that, see setTickLabels.

See also
  setSubTicks

## § setTickLabels()

void QCPPolarAxisRadial::setTickLabels | ( | bool | show | ) |

Sets whether tick labels are displayed. Tick labels are the numbers drawn next to tick marks.

## § setTickLabelPadding()

void QCPPolarAxisRadial::setTickLabelPadding | ( | int | padding | ) |

Sets the distance between the axis base line (including any outward ticks) and the tick labels.

See also
  setLabelPadding, setPadding

## § setTickLabelFont()

void QCPPolarAxisRadial::setTickLabelFont | ( | const QFont & | font | ) |

Sets the font of the tick labels.

See also
  setTickLabels, setTickLabelColor

## § setTickLabelColor()

void QCPPolarAxisRadial::setTickLabelColor | ( | const QColor & | color | ) |

Sets the color of the tick labels.

See also
  setTickLabels, setTickLabelFont

## § setTickLabelRotation()

void QCPPolarAxisRadial::setTickLabelRotation | ( | double | degrees | ) |

Sets the rotation of the tick labels. If degrees is zero, the labels are drawn normally. Else, the tick labels are drawn rotated by degrees clockwise. The specified angle is bound to values from -90 to 90 degrees.

If degrees is exactly -90, 0 or 90, the tick labels are centered on the tick coordinate. For other angles, the label is drawn with an offset such that it seems to point toward or away from the tick mark.

## § setNumberFormat()

void QCPPolarAxisRadial::setNumberFormat | ( | const QString & | formatCode | ) |

Sets the number format for the numbers in tick labels. This formatCode is an extended version of the format code used e.g. by QString::number() and QLocale::toString(). For reference about that, see the "Argument Formats" section in the detailed description of the QString class.

formatCode is a string of one, two or three characters. The first character is identical to the normal format code used by Qt. In short, this means: 'e'/'E' scientific format, 'f' fixed format, 'g'/'G' scientific or fixed, whichever is shorter.

The second and third characters are optional and specific to QCustomPlot:
If the first char was 'e' or 'g', numbers are/might be displayed in the scientific format, e.g. "5.5e9", which is ugly in a plot. So when the second char of formatCode is set to 'b' (for "beautiful"), those exponential numbers are formatted in a more natural way, i.e. "5.5 [multiplication sign] 10 [superscript] 9". By default, the multiplication sign is a centered dot. If instead a cross should be shown (as is usual in the USA), the third char of formatCode can be set to 'c'. The inserted multiplication signs are the UTF-8 characters 215 (0xD7) for the cross and 183 (0xB7) for the dot.

Examples for formatCode:

- `g` normal format code behaviour. If number is small, fixed format is used, if number is large, normal scientific format is used
- `gb` If number is small, fixed format is used, if number is large, scientific format is used with beautifully typeset decimal powers and a dot as multiplication sign
- `ebc` All numbers are in scientific format with beautifully typeset decimal power and a cross as multiplication sign
- `fb` illegal format code, since fixed format doesn't support (or need) beautifully typeset decimal powers. Format code will be reduced to 'f'.
- `hello` illegal format code, since first char is not 'e', 'E', 'f', 'g' or 'G'. Current format code will not be changed.

## § setNumberPrecision()

void QCPPolarAxisRadial::setNumberPrecision | ( | int | precision | ) |

Sets the precision of the tick label numbers. See QLocale::toString(double i, char f, int prec) for details. The effect of precisions are most notably for number Formats starting with 'e', see setNumberFormat

## § setTickLength()

void QCPPolarAxisRadial::setTickLength | ( | int | inside,
|  | int | outside = `0`
| ) |  |

Sets the length of the ticks in pixels. inside is the length the ticks will reach inside the plot and outside is the length they will reach outside the plot. If outside is greater than zero, the tick labels and axis label will increase their distance to the axis accordingly, so they won't collide with the ticks.

See also
  setSubTickLength, setTickLengthIn, setTickLengthOut

## § setTickLengthIn()

void QCPPolarAxisRadial::setTickLengthIn | ( | int | inside | ) |

Sets the length of the inward ticks in pixels. inside is the length the ticks will reach inside the plot.

See also
  setTickLengthOut, setTickLength, setSubTickLength

## § setTickLengthOut()

void QCPPolarAxisRadial::setTickLengthOut | ( | int | outside | ) |

Sets the length of the outward ticks in pixels. outside is the length the ticks will reach outside the plot. If outside is greater than zero, the tick labels and axis label will increase their distance to the axis accordingly, so they won't collide with the ticks.

See also
  setTickLengthIn, setTickLength, setSubTickLength

## § setSubTicks()

void QCPPolarAxisRadial::setSubTicks | ( | bool | show | ) |

Sets whether sub tick marks are displayed.

Sub ticks are only potentially visible if (major) ticks are also visible (see setTicks)

See also
  setTicks

## § setSubTickLength()

void QCPPolarAxisRadial::setSubTickLength | ( | int | inside,
|  | int | outside = `0`
| ) |  |

Sets the length of the subticks in pixels. inside is the length the subticks will reach inside the plot and outside is the length they will reach outside the plot. If outside is greater than zero, the tick labels and axis label will increase their distance to the axis accordingly, so they won't collide with the ticks.

See also
  setTickLength, setSubTickLengthIn, setSubTickLengthOut

## § setSubTickLengthIn()

void QCPPolarAxisRadial::setSubTickLengthIn | ( | int | inside | ) |

Sets the length of the inward subticks in pixels. inside is the length the subticks will reach inside the plot.

See also
  setSubTickLengthOut, setSubTickLength, setTickLength

## § setSubTickLengthOut()

void QCPPolarAxisRadial::setSubTickLengthOut | ( | int | outside | ) |

Sets the length of the outward subticks in pixels. outside is the length the subticks will reach outside the plot. If outside is greater than zero, the tick labels will increase their distance to the axis accordingly, so they won't collide with the ticks.

See also
  setSubTickLengthIn, setSubTickLength, setTickLength

## § setBasePen()

void QCPPolarAxisRadial::setBasePen | ( | const QPen & | pen | ) |

Sets the pen, the axis base line is drawn with.

See also
  setTickPen, setSubTickPen

## § setTickPen()

void QCPPolarAxisRadial::setTickPen | ( | const QPen & | pen | ) |

Sets the pen, tick marks will be drawn with.

See also
  setTickLength, setBasePen

## § setSubTickPen()

void QCPPolarAxisRadial::setSubTickPen | ( | const QPen & | pen | ) |

Sets the pen, subtick marks will be drawn with.

See also
  setSubTickCount, setSubTickLength, setBasePen

## § setLabelFont()

void QCPPolarAxisRadial::setLabelFont | ( | const QFont & | font | ) |

Sets the font of the axis label.

See also
  setLabelColor

## § setLabelColor()

void QCPPolarAxisRadial::setLabelColor | ( | const QColor & | color | ) |

Sets the color of the axis label.

See also
  setLabelFont

## § setLabel()

void QCPPolarAxisRadial::setLabel | ( | const QString & | str | ) |

Sets the text of the axis label that will be shown below/above or next to the axis, depending on its orientation. To disable axis labels, pass an empty string as str.

## § setLabelPadding()

void QCPPolarAxisRadial::setLabelPadding | ( | int | padding | ) |

Sets the distance between the tick labels and the axis label.

See also
  setTickLabelPadding, setPadding

## § setSelectedTickLabelFont()

void QCPPolarAxisRadial::setSelectedTickLabelFont | ( | const QFont & | font | ) |

Sets the font that is used for tick labels when they are selected.

See also
  setTickLabelFont, setSelectableParts, setSelectedParts, QCustomPlot::setInteractions

## § setSelectedLabelFont()

void QCPPolarAxisRadial::setSelectedLabelFont | ( | const QFont & | font | ) |

Sets the font that is used for the axis label when it is selected.

See also
  setLabelFont, setSelectableParts, setSelectedParts, QCustomPlot::setInteractions

## § setSelectedTickLabelColor()

void QCPPolarAxisRadial::setSelectedTickLabelColor | ( | const QColor & | color | ) |

Sets the color that is used for tick labels when they are selected.

See also
  setTickLabelColor, setSelectableParts, setSelectedParts, QCustomPlot::setInteractions

## § setSelectedLabelColor()

void QCPPolarAxisRadial::setSelectedLabelColor | ( | const QColor & | color | ) |

Sets the color that is used for the axis label when it is selected.

See also
  setLabelColor, setSelectableParts, setSelectedParts, QCustomPlot::setInteractions

## § setSelectedBasePen()

void QCPPolarAxisRadial::setSelectedBasePen | ( | const QPen & | pen | ) |

Sets the pen that is used to draw the axis base line when selected.

See also
  setBasePen, setSelectableParts, setSelectedParts, QCustomPlot::setInteractions

## § setSelectedTickPen()

void QCPPolarAxisRadial::setSelectedTickPen | ( | const QPen & | pen | ) |

Sets the pen that is used to draw the (major) ticks when selected.

See also
  setTickPen, setSelectableParts, setSelectedParts, QCustomPlot::setInteractions

## § setSelectedSubTickPen()

void QCPPolarAxisRadial::setSelectedSubTickPen | ( | const QPen & | pen | ) |

Sets the pen that is used to draw the subticks when selected.

See also
  setSubTickPen, setSelectableParts, setSelectedParts, QCustomPlot::setInteractions

## § setSelectableParts()

void QCPPolarAxisRadial::setSelectableParts | ( | const QCPPolarAxisRadial::SelectableParts & | selectableParts | ) |

Sets whether the user can (de-)select the parts in selectable by clicking on the QCustomPlot surface. (When QCustomPlot::setInteractions contains iSelectAxes.)

However, even when selectable is set to a value not allowing the selection of a specific part, it is still possible to set the selection of this part manually, by calling setSelectedParts directly.

See also
  SelectablePart, setSelectedParts

## § setSelectedParts()

void QCPPolarAxisRadial::setSelectedParts | ( | const QCPPolarAxisRadial::SelectableParts & | selectedParts | ) |

Sets the selected state of the respective axis parts described by SelectablePart. When a part is selected, it uses a different pen/font.

The entire selection mechanism for axes is handled automatically when QCustomPlot::setInteractions contains iSelectAxes. You only need to call this function when you wish to change the selection state manually.

This function can change the selection state of a part, independent of the setSelectableParts setting.

emits the selectionChanged signal when selected is different from the previous selection state.

See also
  SelectablePart, setSelectableParts, selectTest, setSelectedBasePen, setSelectedTickPen, setSelectedSubTickPen, setSelectedTickLabelFont, setSelectedLabelFont, setSelectedTickLabelColor, setSelectedLabelColor

## § selectTest()

double QCPPolarAxisRadial::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

In the case of 1D Plottables (QCPAbstractPlottable1D, like QCPGraph or QCPBars) details will be set to a QCPDataSelection, describing the closest data point to pos.

You may pass `nullptr` as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, mousePressEvent, wheelEvent, QCustomPlot::setInteractions, QCPAbstractPlottable1D::selectTestRect

Reimplemented from QCPLayerable.

## § moveRange()

void QCPPolarAxisRadial::moveRange | ( | double | diff | ) |

If the scale type (setScaleType) is stLinear, diff is added to the lower and upper bounds of the range. The range is simply moved by diff.

If the scale type is stLogarithmic, the range bounds are multiplied by diff. This corresponds to an apparent "linear" move in logarithmic scaling by a distance of log(diff).

## § scaleRange() [1/2]

void QCPPolarAxisRadial::scaleRange | ( | double | factor | ) |

Scales the range of this axis by factor around the center of the current axis range. For example, if factor is 2.0, then the axis range will double its size, and the point at the axis range center won't have changed its position in the QCustomPlot widget (i.e. coordinates around the center will have moved symmetrically closer).

If you wish to scale around a different coordinate than the current axis range center, use the overload scaleRange(double factor, double center).

## § scaleRange() [2/2]

void QCPPolarAxisRadial::scaleRange | ( | double | factor,
|  | double | center
| ) |  |

This is an overloaded function.

Scales the range of this axis by factor around the coordinate center. For example, if factor is 2.0, center is 1.0, then the axis range will double its size, and the point at coordinate 1.0 won't have changed its position in the QCustomPlot widget (i.e. coordinates around 1.0 will have moved symmetrically closer to 1.0).

See also
  scaleRange(double factor)

## § rescale()

void QCPPolarAxisRadial::rescale | ( | bool | onlyVisiblePlottables = `false` | ) |

Changes the axis range such that all plottables associated with this axis are fully visible in that dimension.

See also
  QCPAbstractPlottable::rescaleAxes, QCustomPlot::rescaleAxes

## § pixelToCoord()

void QCPPolarAxisRadial::pixelToCoord | ( | QPointF | pixelPos,
|  | double & | angleCoord,
|  | double & | radiusCoord
| ) |  | const

Transforms value, in pixel coordinates of the QCustomPlot widget, to axis coordinates.

## § coordToPixel()

QPointF QCPPolarAxisRadial::coordToPixel | ( | double | angleCoord,
|  | double | radiusCoord
| ) |  | const

Transforms value, in coordinates of the axis, to pixel coordinates of the QCustomPlot widget.

## § getPartAt()

QCPPolarAxisRadial::SelectablePart QCPPolarAxisRadial::getPartAt | ( | const QPointF & | pos | ) | const

Returns the part of the axis that is hit by pos (in pixels). The return value of this function is independent of the user-selectable parts defined with setSelectableParts. Further, this function does not change the current selection state of the axis.

If the axis is not visible (setVisible), this function always returns spNone.

See also
  setSelectedParts, setSelectableParts, QCustomPlot::setInteractions

## § rangeChanged [1/2]

void QCPPolarAxisRadial::rangeChanged | ( | const QCPRange & | newRange | ) |
| signal

This signal is emitted when the range of this axis has changed. You can connect it to the setRange slot of another axis to communicate the new range to the other axis, in order for it to be synchronized.

You may also manipulate/correct the range with setRange in a slot connected to this signal. This is useful if for example a maximum range span shall not be exceeded, or if the lower/upper range shouldn't go beyond certain values (see QCPRange::bounded). For example, the following slot would limit the x axis to ranges between 0 and 10:

customPlot->xAxis->setRange(newRange.bounded(0, 10))

## § rangeChanged [2/2]

void QCPPolarAxisRadial::rangeChanged | ( | const QCPRange & | newRange,
|  | const QCPRange & | oldRange
| ) |  |
| signal

This is an overloaded function.

Additionally to the new range, this signal also provides the previous range held by the axis as oldRange.

## § scaleTypeChanged

void QCPPolarAxisRadial::scaleTypeChanged | ( | QCPPolarAxisRadial::ScaleType | scaleType | ) |
| signal

This signal is emitted when the scale type changes, by calls to setScaleType

## § selectionChanged

void QCPPolarAxisRadial::selectionChanged | ( | const QCPPolarAxisRadial::SelectableParts & | parts | ) |
| signal

This signal is emitted when the selection state of this axis has changed, either by user interaction or by a direct call to setSelectedParts.

## § selectableChanged

void QCPPolarAxisRadial::selectableChanged | ( | const QCPPolarAxisRadial::SelectableParts & | parts | ) |
| signal

This signal is emitted when the selectability changes, by calls to setSelectableParts

## § applyDefaultAntialiasingHint()

void QCPPolarAxisRadial::applyDefaultAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedvirtual

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing axis lines.

This is the antialiasing state the painter passed to the draw method is in by default.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

For general information about this virtual method, see the base class implementation.

See also
  setAntialiased

Implements QCPLayerable.

## § draw()

void QCPPolarAxisRadial::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

Draws the axis with the specified painter, using the internal QCPAxisPainterPrivate instance.

For general information about this virtual method, see the base class implementation.

Implements QCPLayerable.

## § selectionCategory()

QCP::Interaction QCPPolarAxisRadial::selectionCategory | ( |  | ) | const
| protectedvirtual

Returns the selection category this layerable shall belong to. The selection category is used in conjunction with QCustomPlot::setInteractions to control which objects are selectable and which aren't.

Subclasses that don't fit any of the normal QCP::Interaction values can use QCP::iSelectOther. This is what the default implementation returns.

See also
  QCustomPlot::setInteractions

Reimplemented from QCPLayerable.

## § selectEvent()

void QCPPolarAxisRadial::selectEvent | ( | QMouseEvent * | event,
|  | bool | additive,
|  | const QVariant & | details,
|  | bool * | selectionStateChanged
| ) |  |
| protectedvirtual

This event is called when the layerable shall be selected, as a consequence of a click by the user. Subclasses should react to it by setting their selection state appropriately. The default implementation does nothing.

event is the mouse event that caused the selection. additive indicates, whether the user was holding the multi-select-modifier while performing the selection (see QCustomPlot::setMultiSelectModifier). if additive is true, the selection state must be toggled (i.e. become selected when unselected and unselected when selected).

Every selectEvent is preceded by a call to selectTest, which has returned positively (i.e. returned a value greater than 0 and less than the selection tolerance of the parent QCustomPlot). The details data you output from selectTest is fed back via details here. You may use it to transport any kind of information from the selectTest to the possibly subsequent selectEvent. Usually details is used to transfer which part was clicked, if it is a layerable that has multiple individually selectable parts (like QCPAxis). This way selectEvent doesn't need to do the calculation again to find out which part was actually clicked.

selectionStateChanged is an output parameter. If the pointer is non-null, this function must set the value either to true or false, depending on whether the selection state of this layerable was actually changed. For layerables that only are selectable as a whole and not in parts, this is simple: if additive is true, selectionStateChanged must also be set to true, because the selection toggles. If additive is false, selectionStateChanged is only set to true, if the layerable was previously unselected and now is switched to the selected state.

See also
  selectTest, deselectEvent

Reimplemented from QCPLayerable.

## § deselectEvent()

void QCPPolarAxisRadial::deselectEvent | ( | bool * | selectionStateChanged | ) |
| protectedvirtual

This event is called when the layerable shall be deselected, either as consequence of a user interaction or a call to QCustomPlot::deselectAll. Subclasses should react to it by unsetting their selection appropriately.

just as in selectEvent, the output parameter selectionStateChanged (if non-null), must return true or false when the selection state of this layerable has changed or not changed, respectively.

See also
  selectTest, selectEvent

Reimplemented from QCPLayerable.

## § mousePressEvent()

void QCPPolarAxisRadial::mousePressEvent | ( | QMouseEvent * | event,
|  | const QVariant & | details
| ) |  |
| protectedvirtual

This mouse event reimplementation provides the functionality to let the user drag individual axes exclusively, by startig the drag on top of the axis.

For the axis to accept this event and perform the single axis drag, the parent QCPAxisRect must be configured accordingly, i.e. it must allow range dragging in the orientation of this axis (QCPAxisRect::setRangeDrag) and this axis must be a draggable axis (QCPAxisRect::setRangeDragAxes)

For general information about this virtual method, see the base class implementation.

Note
  The dragging of possibly multiple axes at once by starting the drag anywhere in the axis rect is handled by the axis rect's mouse event, e.g. QCPAxisRect::mousePressEvent.

Reimplemented from QCPLayerable.

## § mouseMoveEvent()

void QCPPolarAxisRadial::mouseMoveEvent | ( | QMouseEvent * | event,
|  | const QPointF & | startPos
| ) |  |
| protectedvirtual

This mouse event reimplementation provides the functionality to let the user drag individual axes exclusively, by startig the drag on top of the axis.

For general information about this virtual method, see the base class implementation.

Note
  The dragging of possibly multiple axes at once by starting the drag anywhere in the axis rect is handled by the axis rect's mouse event, e.g. QCPAxisRect::mousePressEvent.

See also
  QCPAxis::mousePressEvent

Reimplemented from QCPLayerable.

## § mouseReleaseEvent()

void QCPPolarAxisRadial::mouseReleaseEvent | ( | QMouseEvent * | event,
|  | const QPointF & | startPos
| ) |  |
| protectedvirtual

This mouse event reimplementation provides the functionality to let the user drag individual axes exclusively, by startig the drag on top of the axis.

For general information about this virtual method, see the base class implementation.

Note
  The dragging of possibly multiple axes at once by starting the drag anywhere in the axis rect is handled by the axis rect's mouse event, e.g. QCPAxisRect::mousePressEvent.

See also
  QCPAxis::mousePressEvent

Reimplemented from QCPLayerable.

## § wheelEvent()

void QCPPolarAxisRadial::wheelEvent | ( | QWheelEvent * | event | ) |
| protectedvirtual

This mouse event reimplementation provides the functionality to let the user zoom individual axes exclusively, by performing the wheel event on top of the axis.

For the axis to accept this event and perform the single axis zoom, the parent QCPAxisRect must be configured accordingly, i.e. it must allow range zooming in the orientation of this axis (QCPAxisRect::setRangeZoom) and this axis must be a zoomable axis (QCPAxisRect::setRangeZoomAxes)

For general information about this virtual method, see the base class implementation.

Note
  The zooming of possibly multiple axes at once by performing the wheel event anywhere in the axis rect is handled by the axis rect's mouse event, e.g. QCPAxisRect::wheelEvent.

Reimplemented from QCPLayerable.

## § setupTickVectors()

void QCPPolarAxisRadial::setupTickVectors | ( |  | ) |
| protected

Prepares the internal tick vector, sub tick vector and tick label vector. This is done by calling QCPAxisTicker::generate on the currently installed ticker.

If a change in the label text/count is detected, the cached axis margin is invalidated to make sure the next margin calculation recalculates the label sizes and returns an up-to-date value.

## § getBasePen()

QPen QCPPolarAxisRadial::getBasePen | ( |  | ) | const
| protected

Returns the pen that is used to draw the axis base line. Depending on the selection state, this is either mSelectedBasePen or mBasePen.

## § getTickPen()

QPen QCPPolarAxisRadial::getTickPen | ( |  | ) | const
| protected

Returns the pen that is used to draw the (major) ticks. Depending on the selection state, this is either mSelectedTickPen or mTickPen.

## § getSubTickPen()

QPen QCPPolarAxisRadial::getSubTickPen | ( |  | ) | const
| protected

Returns the pen that is used to draw the subticks. Depending on the selection state, this is either mSelectedSubTickPen or mSubTickPen.

## § getTickLabelFont()

QFont QCPPolarAxisRadial::getTickLabelFont | ( |  | ) | const
| protected

Returns the font that is used to draw the tick labels. Depending on the selection state, this is either mSelectedTickLabelFont or mTickLabelFont.

## § getLabelFont()

QFont QCPPolarAxisRadial::getLabelFont | ( |  | ) | const
| protected

Returns the font that is used to draw the axis label. Depending on the selection state, this is either mSelectedLabelFont or mLabelFont.

## § getTickLabelColor()

QColor QCPPolarAxisRadial::getTickLabelColor | ( |  | ) | const
| protected

Returns the color that is used to draw the tick labels. Depending on the selection state, this is either mSelectedTickLabelColor or mTickLabelColor.

## § getLabelColor()

QColor QCPPolarAxisRadial::getLabelColor | ( |  | ) | const
| protected

Returns the color that is used to draw the axis label. Depending on the selection state, this is either mSelectedLabelColor or mLabelColor.

The documentation for this class was generated from the following files:

- src/polar/radialaxis.h
- src/polar/radialaxis.cpp